#!/usr/bin/php
<?php

$time_first = time();
$time_date = date('d-m H:i');

$options = getopt("DU:N:M:c:");
$ini_conf=array();
if(!empty($options["c"]))
{
	$configfile = $options["c"];
}
else
{
	$configfile = '/etc/esia/graph.conf';
}
if(file_exists($configfile)===FALSE)
{
	echo "Configuration file not exist $configfile\n";
	exit(1);
}
include_once $configfile;
$_SERVER['DOCUMENT_ROOT']=$SERVER['DOCUMENT_ROOT'];
include_once $SERVER['ESIA_CONF'];
$RRD['PATH'] =RRA_DIRECTORY;
//Chargement fichier de configuration esia
include_once '/usr/local/esia/poller/libs/EventManager.class.php';
//PARAMETRE DE CREATION DES RRD


//EVENT MANAGER
if(file_exists('/usr/local/esia/poller/migrate.lock')===TRUE)
{
	echo "mode maintenance\n";
	exit(0);
}
if(is_dir($SERVER['TMPDIR'])===FALSE)
{
	mkdir($SERVER['TMPDIR'],0755);
}
$EVM=new EventManager();
// l'usage des ticks est nécessaire depuis PHP 4.3.0
declare(ticks = 1);
$POLLER=NULL;
$MAXPOLLER=NULL;
if(isset($options["N"])  && isset($options["M"]) )
{
	$POLLER=$options["N"];
	$MAXPOLLER=$options["M"];
	$EVM->notify("Poller DATA $POLLER $MAXPOLLER",E_USER_NOTICE);
}
//on vérifie si on est en mode DEBUG
if(isset($options["D"])  || $ini_conf['CORE']['debug'] == 1)
{
	//mode Debug ON
	$EVM->addEventListener(new stdoutLogger(),E_USER_NOTICE);
}
else
{
	//mode Debug OFF
	$EVM->addEventListener(new stdoutLogger(),false);
}
$EVM->addEventListener(new fileLogger("graph_$POLLER.log",$SERVER['LOGDIR'],false),E_USER_WARNING);
$EVM->notify("Poller START",E_USER_ERROR);
if($POLLER != 0 )
{
	$time = $POLLER * 15;
	sleep($time);
}
//Ajout verrou par julien
$lock_path = $SERVER['TMPDIR']."graph_$POLLER.lock";
$fp = fopen($lock_path, 'w+');
if(!flock($fp,LOCK_EX|LOCK_NB)){
	echo "Script is already used\n";
    	$EVM->notify("Poller already started. Waiting 5 seconds",E_USER_NOTICE);
	sleep(5);
}

if(!flock($fp,LOCK_EX|LOCK_NB)){
	echo "Script is already used\n";
    $EVM->notify("Poller already started. Waiting 5 seconds",E_USER_NOTICE);
	sleep(5);
}

if(!flock($fp,LOCK_EX|LOCK_NB)){
	echo "Script is already used\n";
    $EVM->notify("Poller already started. Stop current script",E_USER_ERROR);
    file_put_contents("/tmp/graph_1min$POLLER.stats",$time_date."|".implode(':',$time_arr)."NOT RUN\n",FILE_APPEND);
    exit(0);
}

$EVM->notify("Poller Start",E_USER_NOTICE);
try
{
    $EVM->notify("Connexion base de donnée",E_USER_NOTICE);
    //connection à la base de donnée
    try
    {
	    $dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
	    $dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
    }
    catch(Exception $e)
    {
	    echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
	    echo 'N° : '.$e->getCode();
        exit(1);
    }
    $EVM->notify("Connexion base de donnée SUCCESS",E_USER_NOTICE);
    //on prépare la requète qui récupére les informations sur la base rrdtool
    $query = $dbconnection->prepare("SELECT rrd_plugin_id,rrd_type,rrd_regex,rrd_time,rrd_name,rrd_max,rrd_min,rrd_graph_num,rrd_calc FROM rrd_plugins ORDER BY rrd_plugin_id,rrd_graph_num;");
    $ret = $query->execute();
    if($ret===false)
    {
        $err = $query->errorInfo();
        echo "DB error: ".$err[2]."\n";
        exit(0);
    }
    //
    $arr_rrd_parameter=array();
    $arr_plugin_id = array();
    while($row=$query->fetch(PDO::FETCH_ASSOC))
    {
        $plugin_id = $row['rrd_plugin_id'];
		if(!in_array($row['rrd_plugin_id'],$arr_plugin_id))
		{
			$arr_plugin_id[]= $row['rrd_plugin_id'];
        }
		$graph_num = $row['rrd_graph_num'];
        if(array_key_exists($plugin_id,$arr_rrd_parameter))
        {
            if(array_key_exists($graph_num,$arr_rrd_parameter[$plugin_id]))
            {
                array_push($arr_rrd_parameter[$plugin_id][$graph_num],$row);
            }
            else
            {
                $arr_rrd_parameter[$plugin_id][$graph_num][]=$row;
            }
        }
        else
        {
            $arr_rrd_parameter[$plugin_id][$graph_num][]=$row;
        }
    }
	$arr_plugin_id = implode(',', $arr_plugin_id);

    // Création des nouveaux fichiers RRD.
	$sql = "SELECT DISTINCT device_name,service_id,service_name,service_plugin_id,plugin_name
									FROM esia_services as t2
									JOIN esia_device ON device_id = service_device_id
									JOIN esia_plugins ON plugin_id = service_plugin_id
									WHERE service_plugin_id IN ($arr_plugin_id)
										AND NOT EXISTS (SELECT 1  FROM esia_service_rra_file WHERE t2.service_id=rra_service_id);";

	$query= $dbconnection->prepare($sql);
    $ret = $query->execute();
    $queryinsert= $dbconnection->prepare("INSERT INTO esia_service_rra_file(rra_file_id, rra_service_id,rra_graph_num, rra_file_path)VALUES (DEFAULT,:id,:graph, :path);");
    $EVM->notify("CREATION NOUVEAU FICHIER",E_USER_NOTICE);
	while($row=$query->fetch(PDO::FETCH_OBJ))
    {
        $nodename= preg_replace('#\s#','_',$row->device_name);
        $nodename= preg_replace('#\/#','_',$nodename);
        $nodename= preg_replace('#\\\\#','_',$nodename);
		$EVM->notify("CREATION NOUVEAU FICHIER: $nodename",E_USER_NOTICE);
		if(!is_dir($RRD['PATH'].$nodename))
		{
			if (!mkdir($RRD['PATH'].$nodename, 0755, false))
			{
				$EVM->notify("Failed create folder ".$RRD['PATH']."$nodename",E_USER_ERROR);
			}
		}
		$plugins_rrd = $arr_rrd_parameter[$row->service_plugin_id];
		foreach($plugins_rrd as $rows_rrd)
	    {
	    	//print_r($rows_rrd);
			$filename = $RRD['PATH'].$nodename.'/'.$row->plugin_name.$row->service_id.$rows_rrd[0]['rrd_graph_num'].'.rrd';
			if(file_exists($filename)===FALSE)
			{
				//préparation des paramètres
				$creator = new RRDCreator($filename,0, $rows_rrd[0]['rrd_time']);
				//
				$unknown_point = $RRD['TIME']*2;
				foreach($rows_rrd as $ds)
				{
						    $min='U';
						    $max='U';
						    if($ds['rrd_min']!=-1)
							    $min=$ds['rrd_min'];
						    if($ds['rrd_max']!=-1)
							    $max=$ds['rrd_max'];
		                    $creator->addDataSource($ds['rrd_name'].":".$ds['rrd_type'].":".$unknown_point.":".$min.":".$max);
				}
				foreach($RRD['RRA'] as $line)
		        {
					$creator->addArchive($line);
				}
				$ret = $creator->save();
				if( $ret === FALSE )
				{
					$err = rrd_error();
					$EVM->notify("Create error: $err",E_USER_ERROR);
				}
				$queryinsert->execute(array(':id'=>$row->service_id,
											':graph'=>$rows_rrd[0]['rrd_graph_num'],
											':path'=>$nodename.'/'.$row->plugin_name.$row->service_id.$rows_rrd[0]['rrd_graph_num'].'.rrd'));
			}
			else
			{
				$queryinsert->execute(array(':id'=>$row->service_id,
											':graph'=>$rows_rrd[0]['rrd_graph_num'],
											':path'=>$nodename.'/'.$row->plugin_name.$row->service_id.$rows_rrd[0]['rrd_graph_num'].'.rrd'));
			}
		}
	}
    $EVM->notify("Récupération des données $MAXPOLLER $POLLER",E_USER_NOTICE);
    $sql ="SELECT DISTINCT service_device_id,service_id,service_plugin_id,service_last_stdout,rra_file_path,rra_graph_num
									FROM esia_services
									JOIN esia_service_rra_file ON service_id = rra_service_id
									ORDER BY service_device_id";
	if(!empty($MAXPOLLER))
	{
		$query= $dbconnection->prepare("SELECT count(*) as nbr
									FROM esia_services
									JOIN esia_service_rra_file ON service_id = rra_service_id;");
		$ret = $query->execute();
		$row=$query->fetch(PDO::FETCH_OBJ);
		$delta = intval($row->nbr / $MAXPOLLER);
		$start = $POLLER * $delta;
		//$stop = $start+$delta;
		$sql .= " LIMIT $delta OFFSET $start";
		$EVM->notify("Récupération des données $sql",E_USER_NOTICE);
	}
    //on recupère les données
    $query= $dbconnection->prepare($sql);
    $ret = $query->execute();
    if($ret===false)
    {
	    $err = $query->errorInfo();
	    echo "DB error: ".$err[2]."\n";
	    exit(0);
    }
    $list_graph_file = $query->fetchAll(PDO::FETCH_CLASS);
    $date = new Datetime("now");
	$start = $date->getTimestamp();
		foreach( $list_graph_file  as $row )
		{
			try
			{
			if(array_key_exists($row->service_plugin_id,$arr_rrd_parameter) ===true )
			{
			    $num = $row->rra_graph_num;
			    $rows_rrd = $arr_rrd_parameter[$row->service_plugin_id]["$num"];
				if(!empty($rows_rrd))
				{
					//$EVM->notify("Création worker ".$row->rra_file_path ,E_USER_NOTICE);
					$filename = $RRD['PATH'].$row->rra_file_path;
					$com_ds='';
					$com_value='';
					foreach($rows_rrd as $ds)
					{
						if(!empty($com_ds))
						{
							$com_ds.=':';
						}
						if(empty($com_value))
						{
							$com_value='N:';
						}
						else
						{
							$com_value.=':';
						}
						$com_ds.= $ds['rrd_name'];
					    if(preg_match($ds['rrd_regex'],$row->service_last_stdout,$regs))
					    {
						    $value = preg_replace('#,#','.',$regs[1]);
		                    if(!empty($value))
		                    {
						        if(preg_match('#([\*\/\+\-\%])([0-9]*)#',$ds['rrd_calc'],$calc))
						        {
							        switch($calc[1])
							        {
								        case '+': $value=$value+$calc[2];  break;
								        case '-': $value=$value-$calc[2];  break;
								        case '*': $value=$value*$calc[2];  break;
								        case '/': $value=$value/$calc[2];  break;
								        case '%': $value=$value%$calc[2];  break;
								        default: break;
							        }
						        }
						        $com_value.= $value;
		                    }
		                    else
		                    {
						        $com_value.='U';
		                    }
					    }
					    else
					    {
						    $com_value.='U';
					    }
					}
					echo $filename.':'." DS: $com_ds=>$com_value $filename\n";
					$parameter = array();
					if(!empty($RRD['CACHED']))
					{
						$parameter[]='-d';
						$parameter[]=$RRD['CACHED'];
					}
					$parameter[]='-t';
					$parameter[]=$com_ds;
					$parameter[]=$com_value;
					$ret = rrd_update($filename,$parameter);
					if( $ret == 0 )
					{
						$err = rrd_error();
						throw new Exception("update error: $err");
					}
				}
			}
		}

		catch(Exception $e)
		{
			$EVM->notify($e->getMessage(),E_USER_ERROR);
		}
	}
}
catch(Exception $e)
{
    $EVM->notify($e->getMessage(),E_USER_ERROR);
}
exit(0);
